## mrpt 0.9.4

=== CMakeLists.txt ===
# ----------------------------------------------------------------------------
# Root CMake file for the MRPT libraries and applications
#
#  Run with "cmake ." at the root directory to build the makefiles for
#   the MRPT C++ library, the samples, and the applications. Some scripts
#   for generating the documentation, etc... are also updated.
#
#  For compiling instructions for all compilers and platforms, see 
#   http://www.mrpt.org/Building_and_Installing_Instructions
#
#  2007-2011, Jose Luis Blanco <jlblanco@ctima.uma.es>
#
#  NOTE: CMake can be obtained at http://www.cmake.org/
# ----------------------------------------------------------------------------

PROJECT(MRPT)
if(MSVC)
	CMAKE_MINIMUM_REQUIRED(VERSION 2.6.4)
else(MSVC)
	CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
endif(MSVC)

# --------------------------------------------------------------
# Indicate CMake 2.7 and above that we don't want to mix relative
#  and absolute paths in linker lib lists.
# Run "cmake --help-policy CMP0003" for more information.
# --------------------------------------------------------------
if(COMMAND cmake_policy)
      cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

# ----------------------------------------------------------------------------
#  Loads the current version number:
# ----------------------------------------------------------------------------
FILE(READ "${CMAKE_CURRENT_SOURCE_DIR}/version_prefix.txt" CMAKE_MRPT_VERSION_NUMBER)

# For example: "0.5.1"
STRING(REGEX MATCHALL "[0-9]+" CMAKE_MRPT_VERSION_PARTS "${CMAKE_MRPT_VERSION_NUMBER}")

LIST(GET CMAKE_MRPT_VERSION_PARTS 0 CMAKE_MRPT_VERSION_NUMBER_MAJOR)
LIST(GET CMAKE_MRPT_VERSION_PARTS 1 CMAKE_MRPT_VERSION_NUMBER_MINOR)
LIST(GET CMAKE_MRPT_VERSION_PARTS 2 CMAKE_MRPT_VERSION_NUMBER_PATCH)
SET(CMAKE_MRPT_FULL_VERSION "${CMAKE_MRPT_VERSION_NUMBER_MAJOR}.${CMAKE_MRPT_VERSION_NUMBER_MINOR}.${CMAKE_MRPT_VERSION_NUMBER_PATCH}")

IF(WIN32)
	SET(MRPT_DLL_VERSION_POSTFIX "${CMAKE_MRPT_VERSION_NUMBER_MAJOR}${CMAKE_MRPT_VERSION_NUMBER_MINOR}${CMAKE_MRPT_VERSION_NUMBER_PATCH}")
ELSE(WIN32)
	SET(MRPT_DLL_VERSION_POSTFIX "")
ENDIF(WIN32)

# ----------------------------------------------------------------------------
# The root directory for all MRPT libraries/modules:
# ----------------------------------------------------------------------------
SET(MRPT_LIBS_ROOT "${CMAKE_SOURCE_DIR}/libs" CACHE INTERNAL "")  # This emulates global vars

LIST(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmakemodules")

# Useful macros:
INCLUDE(cmakemodules/UtilsMacros.cmake REQUIRED)

# Detect machine architecture, on UNIX:
if(UNIX)
	execute_process(COMMAND uname -m
		OUTPUT_VARIABLE CMAKE_MRPT_ARCH
                OUTPUT_STRIP_TRAILING_WHITESPACE)
	message(STATUS "Architecture uname -m: ${CMAKE_MRPT_ARCH}")
endif(UNIX)

# ----------------------------------------------------------------------------
# Detect GNU version:
# ----------------------------------------------------------------------------
IF(CMAKE_COMPILER_IS_GNUCXX)
	execute_process(COMMAND ${CMAKE_CXX_COMPILER} --version
		          OUTPUT_VARIABLE CMAKE_MRPT_GCC_VERSION_FULL
		          OUTPUT_STRIP_TRAILING_WHITESPACE)

	# Typical output in CMAKE_MRPT_GCC_VERSION_FULL: "c++ (whatever) 4.2.3 (...)"
	#  Look for the version number
	STRING(REGEX MATCH "[0-9]+.[0-9]+.[0-9]+" CMAKE_GCC_REGEX_VERSION "${CMAKE_MRPT_GCC_VERSION_FULL}")
	#MESSAGE(STATUS "match: ${CMAKE_GCC_REGEX_VERSION}")

	# Split the three parts:
	STRING(REGEX MATCHALL "[0-9]+" CMAKE_MRPT_GCC_VERSIONS "${CMAKE_GCC_REGEX_VERSION}")

	LIST(GET CMAKE_MRPT_GCC_VERSIONS 0 CMAKE_MRPT_GCC_VERSION_MAJOR)
	LIST(GET CMAKE_MRPT_GCC_VERSIONS 1 CMAKE_MRPT_GCC_VERSION_MINOR)

	SET(CMAKE_MRPT_GCC_VERSION ${CMAKE_MRPT_GCC_VERSION_MAJOR}${CMAKE_MRPT_GCC_VERSION_MINOR})
ENDIF(CMAKE_COMPILER_IS_GNUCXX)


# ----------------------------------------------------------------------------
# Include the "CPack" package generator
# ----------------------------------------------------------------------------
SET(CMAKE_INSTALL_DEBUG_LIBRARIES 1)
INCLUDE(InstallRequiredSystemLibraries)

SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "The Mobile Robot Programming Toolkit (MRPT)")
SET(CPACK_PACKAGE_VENDOR "Jose Luis Blanco Claraco")
SET(CPACK_PACKAGE_CONTACT "Jose Luis Blanco Claraco <jlblanco@ctima.uma.es>")

SET(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/README.txt")
SET(CPACK_RESOURCE_FILE_WELCOME "${CMAKE_CURRENT_SOURCE_DIR}/README.txt")
SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "MRPT is a set of C++ libraries and applications for mobile robot software development.")
FILE(READ ${CPACK_PACKAGE_DESCRIPTION_FILE} CPACK_DESCRIPTION_TEXT)

SET(CPACK_PACKAGE_VERSION_MAJOR "${CMAKE_MRPT_VERSION_NUMBER_MAJOR}")
SET(CPACK_PACKAGE_VERSION_MINOR "${CMAKE_MRPT_VERSION_NUMBER_MINOR}")
SET(CPACK_PACKAGE_VERSION_PATCH "${CMAKE_MRPT_VERSION_NUMBER_PATCH}")

SET(CPACK_DEBIAN_PACKAGE_VERSION "${CMAKE_MRPT_VERSION_NUMBER_MAJOR}.${CMAKE_MRPT_VERSION_NUMBER_MINOR}.${CMAKE_MRPT_VERSION_NUMBER_PATCH}")
SET(CPACK_DEBIAN_PACKAGE_DESCRIPTION "${CPACK_PACKAGE_DESCRIPTION_SUMMARY}\r\rThe Mobile Robot Programming Toolkit (MRPT) is an extensive, cross-platform, and open source C++ library aimed to help robotics researchers to design and implement algorithms (mainly) in the fields of Simultaneous Localization and Mapping (SLAM) and computer vision (e.g. MonoSLAM).\rThe library allows an easy interface to many common sensors like laser scanners or cameras, and defines a versatile rawlog file format, used to store data sets gathered by a robot for posterior processing. The MRPT's format for rawlogs is Bayesian filter-friendly: sequences of action-observations, in a generic form that allows 2D/3D(6D) movements and any number of (extensible) observations.\r\r MRPT website: http://mrpt.sourceforge.net\r")

SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/COPYING")
SET(CPACK_RESOURCE_FILE_README "${CMAKE_CURRENT_SOURCE_DIR}/README.txt")

SET(CPACK_SOURCE_GENERATOR "TGZ")

SET(CPACK_PACKAGE_INSTALL_DIRECTORY "mrpt-${CMAKE_MRPT_VERSION_NUMBER_MAJOR}.${CMAKE_MRPT_VERSION_NUMBER_MINOR}.${CMAKE_MRPT_VERSION_NUMBER_PATCH}")

IF(WIN32)
	# --------------------------------
	# Packages for Windows
	# --------------------------------
	SET(CPACK_SOURCE_IGNORE_FILES ".svn/;.*~;build;CMakeCache.txt;_CPack_Pakages/;CMakeFiles/;install/;Makefile;*.cmake")

	# There is a bug in NSI that does not handle full unix paths properly. Make
	# sure there is at least one set of four (4) backlasshes.
	SET(CPACK_NSIS_MUI_ICON "${CMAKE_CURRENT_SOURCE_DIR}/share/pixmaps\\\\mrpt_icon.ico")
	SET(CPACK_NSIS_MUI_UNIICON "${CMAKE_CURRENT_SOURCE_DIR}/share/pixmaps\\\\mrpt_icon.ico")
	SET(CPACK_PACKAGE_ICON "${CMAKE_CURRENT_SOURCE_DIR}/apps/wx-common\\\\mrpt_logo.png")

	SET(CPACK_NSIS_INSTALLED_ICON_NAME "${CMAKE_CURRENT_SOURCE_DIR}/share/pixmaps\\\\mrpt_icon.ico")

	SET(CPACK_NSIS_HELP_LINK "http:\\\\\\\\mrpt.sourceforge.net")
	SET(CPACK_NSIS_URL_INFO_ABOUT "http:\\\\\\\\www.isa.uma.es\\\\jlblanco")
	SET(CPACK_NSIS_CONTACT "jlblanco@ctima.uma.es")
	
	# Add mrpt/bin dir to system PATH
	SET(CPACK_NSIS_MODIFY_PATH ON)

	# Install header and source files:
	# ---------------------------------------------
	INSTALL(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/libs/"
		DESTINATION libs
		PATTERN ".svn" EXCLUDE
		PATTERN "*~" EXCLUDE)

	INSTALL(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/apps/"
		DESTINATION apps
		PATTERN ".svn" EXCLUDE
		PATTERN "*~" EXCLUDE)
		
	INSTALL(FILES 
		cmake_uninstall.cmake.in
		CMakeLists.txt
		config_file_examples.txt
		configure
		COPYING
		DATASETS.txt
		INSTALL_COMPILE.html
		MRPTConfig.cmake.in
		NEWS.html
		README
		README.Debian
		README.txt
		version_prefix.txt
		version_prefix_README.txt
	DESTINATION .)
		
	SET(CPACK_PACKAGE_EXECUTABLES 
		"camera-calib;Camera calibration GUI;features-matching;Visual feature matching;GridmapNavSimul;Gridmap simulator;RawLogViewer;RawLog Viewer;ReactiveNavigationDemo;Reactive navigation demo;prrt-navigator-demo;PRRT robot navigator demo;SceneViewer3D;Scene Viewer 3D;2d-slam-demo;2D KF-SLAM Simulator;navlog-viewer;Viewer of navigation log files;kinect-3d-slam;Simple live 3D-SLAM with Kinect")
		
	IF (EXISTS "${MRPT_SOURCE_DIR}/apps/hmt-slam-gui")
		SET(CPACK_PACKAGE_EXECUTABLES "${CPACK_PACKAGE_EXECUTABLES};hmt-slam-gui;HMT-SLAM visual interface")
	ENDIF (EXISTS "${MRPT_SOURCE_DIR}/apps/hmt-slam-gui")
	
		
	SET(CPACK_NSIS_MENU_LINKS
	    "doc;Documentation directory;bin;Directory of executables (bin);doc/chm/libMRPT-@CMAKE_MRPT_VERSION_NUMBER_MAJOR@.@CMAKE_MRPT_VERSION_NUMBER_MINOR@.@CMAKE_MRPT_VERSION_NUMBER_PATCH@.chm;MRPT libraries reference (CHM);README.txt;Read me;http://www.mrpt.org/;Online help;doc/mrpt-book.pdf;The MRPT book (PDF)")
		
	# File types association:
	SET(CPACK_NSIS_DEFINES "
		!include registerExtension.nsh
		")
	
	SET(CPACK_NSIS_EXTRA_INSTALL_COMMANDS "
		\\\${registerExtension} \\\"$INSTDIR\\\\bin\\\\RawLogViewer.exe\\\" \\\".rawlog\\\" \\\"Robotic Dataset File\\\" 
		\\\${registerExtension} \\\"$INSTDIR\\\\bin\\\\SceneViewer3D.exe\\\" \\\".3Dscene\\\" \\\"Robotic 3D scene\\\" 
		")
	SET(CPACK_NSIS_EXTRA_UNINSTALL_COMMANDS "  
		\\\${unregisterExtension} \\\".rawlog\\\" \\\"Robotic Dataset File\\\" 
		\\\${unregisterExtension} \\\".3Dscene\\\" \\\"Robotic 3D scene\\\" 
		")

	SET(CPACK_NSIS_MODIFY_PATH OFF)  # don't show this dialog

ENDIF(WIN32)
IF(UNIX)
	# --------------------------------
	# Packages for linux
	# --------------------------------
   	SET(CPACK_OUTPUT_FILE_PATH "MRPT-${CMAKE_MRPT_VERSION_NUMBER_MAJOR}.${CMAKE_MRPT_VERSION_NUMBER_MINOR}.${CMAKE_MRPT_VERSION_NUMBER_PATCH}-Linux-${CMAKE_SYSTEM_PROCESSOR}.deb")
	SET(CPACK_DEBIAN_PACKAGE_NAME "libmrpt")
	SET(CPACK_PACKAGING_INSTALL_PREFIX "/usr/local")
	SET(CPACK_DEBIAN_PACKAGE_DEPENDS "libcv1,libglu1-mesa,libwxgtk2.8-0")

	SET(CPACK_DEBIAN_PACKAGE_ARCHITECTURE "${CMAKE_SYSTEM_PROCESSOR}")

	SET(CPACK_SOURCE_IGNORE_FILES ".svn;CMakeFiles;CMakeCache.txt;CPack*;progress.make;install_manifest.txt;cmake_install.cmake;cmake_psdk.cmake$;Makefile;.swp$;.*~;tags;cmake_uninstall.cmake$")

	SET(CPACK_GENERATOR DEB)

ENDIF(UNIX)

IF(APPLE)
	SET(CPACK_GENERATOR "TGZ;TBZ2;OSXX11")
Endif(APPLE)

INCLUDE(CPack)

# ------------------------------------------
# The debug post-fix of .dll /.so libs
# ------------------------------------------
set(CMAKE_DEBUG_POSTFIX  "-dbg")
# Libs are: "libmrpt-xxx"
#            ---
IF(MSVC)	
	set(MRPT_LIB_PREFIX "lib")
ENDIF(MSVC)

# In case of Makefiles if the user does not setup CMAKE_BUILD_TYPE, assume it's Release:
if (${CMAKE_GENERATOR} MATCHES ".*Makefiles")
    if("${CMAKE_BUILD_TYPE}" STREQUAL "")
        set(CMAKE_BUILD_TYPE Release)
    endif()
endif()


# ----------------------------------------------------------------------------
# 		CHECK FOR SYSTEM LIBRARIES, OPTIONS, ETC..
# ----------------------------------------------------------------------------

# Build (or not) some apps:
# ===================================================
SET(BUILD_MONOSLAM OFF CACHE BOOL "Build library mrpt-monoslam")
SET(BUILD_STEREOSLAM OFF CACHE BOOL "Build library mrpt-stereoslam")
MARK_AS_ADVANCED(BUILD_MONOSLAM)
MARK_AS_ADVANCED(BUILD_STEREOSLAM )

# If some app is not in this package, do NOT build it:
# =====================================================
IF (NOT EXISTS "${MRPT_SOURCE_DIR}/libs/monoslam/src")
	SET(BUILD_MONOSLAM OFF CACHE INTERNAL "" FORCE)
ENDIF (NOT EXISTS "${MRPT_SOURCE_DIR}/libs/monoslam/src")

IF (NOT EXISTS "${MRPT_SOURCE_DIR}/libs/stereoslam/src")
	SET(BUILD_STEREOSLAM OFF CACHE INTERNAL "" FORCE)
ENDIF (NOT EXISTS "${MRPT_SOURCE_DIR}/libs/stereoslam/src")


# Build static or dynamic libs?
# ===================================================
# Default: dynamic libraries:
SET(BUILD_SHARED_LIBS ON CACHE BOOL "Build shared libraries (.dll/.so) instead of static ones (.lib/.a)")
IF(BUILD_SHARED_LIBS)
	SET(CMAKE_MRPT_BUILD_SHARED_LIB "#define MRPT_BUILT_AS_DLL")
	SET(CMAKE_MRPT_BUILD_SHARED_LIB_ONOFF 1)

=== apps/CMakeLists.txt ===
# ----------------------------------------------------------------------------
# CMake file. Run with "cmake ." at the root directory.
# ----------------------------------------------------------------------------

INCLUDE(../cmakemodules/AssureCMakeRootFile.cmake) # Avoid user mistake in CMake source directory

add_subdirectory(ReactiveNavigationDemo)
add_subdirectory(navlog-viewer)
add_subdirectory(prrt-navigator-demo)
add_subdirectory(RawLogViewer)
add_subdirectory(3DSceneViewer)
add_subdirectory(2d-slam-demo)
if(EXISTS ${MRPT_SOURCE_DIR}/apps/hmtMapViewer)
	add_subdirectory(hmtMapViewer)
endif(EXISTS ${MRPT_SOURCE_DIR}/apps/hmtMapViewer)
add_subdirectory(camera-calib)

if(EXISTS ${MRPT_SOURCE_DIR}/apps/hmt-slam)
	add_subdirectory(hmt-slam)
endif(EXISTS ${MRPT_SOURCE_DIR}/apps/hmt-slam)
if(EXISTS ${MRPT_SOURCE_DIR}/apps/hmt-slam-gui)
	add_subdirectory(hmt-slam-gui)
endif(EXISTS ${MRPT_SOURCE_DIR}/apps/hmt-slam-gui)

add_subdirectory(rbpf-slam)
add_subdirectory(kf-slam)
add_subdirectory(icp-slam)
add_subdirectory(graph-slam)
add_subdirectory(kinect-3d-slam)

add_subdirectory(simul-beacons)
add_subdirectory(simul-landmarks)
add_subdirectory(simul-gridmap)
#add_subdirectory(simul-stereo-images-features)   # Missing dir!!
add_subdirectory(GridmapNavSimul)

add_subdirectory(grid-matching)
add_subdirectory(pf-localization)
add_subdirectory(ro-localization)
add_subdirectory(map-partition)
add_subdirectory(features-matching)
add_subdirectory(track-video-features)
add_subdirectory(mrpt-performance)

add_subdirectory(rawlog-tools)

# This program requires opencv version 1.1.0:
IF (MRPT_OPENCV_VERSION STRGREATER "1.0.0")
	add_subdirectory(stereo-calib-gui)
ENDIF (MRPT_OPENCV_VERSION STRGREATER "1.0.0")

add_subdirectory(observations2map)
add_subdirectory(rawlog-grabber)

IF (BUILD_STEREOSLAM AND EXISTS "${MRPT_SOURCE_DIR}/apps/vOdometry")
	add_subdirectory(vOdometry)
ENDIF (BUILD_STEREOSLAM AND EXISTS "${MRPT_SOURCE_DIR}/apps/vOdometry")

IF (BUILD_STEREOSLAM AND EXISTS "${MRPT_SOURCE_DIR}/apps/multiResLocalization")
	add_subdirectory(multiResLocalization)
ENDIF (BUILD_STEREOSLAM AND EXISTS "${MRPT_SOURCE_DIR}/apps/multiResLocalization")

if(BUILD_MONOSLAM)
	add_subdirectory(mono-slam)
endif(BUILD_MONOSLAM)

=== apps/map-partition/CMakeLists.txt ===
INCLUDE(../../cmakemodules/AssureCMakeRootFile.cmake) # Avoid user mistake in CMake source directory

#-----------------------------------------------------------------
# CMake file for the MRPT application:  map-partition
#
#  Run with "cmake ." at the root directory
#
#  December 2007, Jose Luis Blanco <jlblanco@ctima.uma.es>
#-----------------------------------------------------------------
PROJECT(map_partition)

#MESSAGE(STATUS "Makefile for application: /apps/map-partition")

# ---------------------------------------------
# TARGET:
# ---------------------------------------------
# Define the executable target:
ADD_EXECUTABLE(map-partition
               map-partition.cpp)

SET(TMP_TARGET_NAME "map-partition")

SET_TARGET_PROPERTIES(${TMP_TARGET_NAME} PROPERTIES PROJECT_LABEL "(APP) ${TMP_TARGET_NAME}")

# Add the required libraries for linking:
TARGET_LINK_LIBRARIES(${TMP_TARGET_NAME} ${MRPT_LINKER_LIBS})

# Dependencies on MRPT libraries:
#  Just mention the top-level dependency, the rest will be detected automatically, 
#  and all the needed #include<> dirs added (see the script DeclareAppDependencies.cmake for further details)
DeclareAppDependencies(${TMP_TARGET_NAME} mrpt-gui mrpt-slam)


# ----------------------------------------------------------------------------
#   				INSTALL
# ----------------------------------------------------------------------------
INSTALL(TARGETS map-partition
	RUNTIME DESTINATION ${mrpt_apps_INSTALL_PREFIX}bin
	LIBRARY DESTINATION ${mrpt_apps_INSTALL_PREFIX}lib${LIB_SUFFIX}
	ARCHIVE DESTINATION ${mrpt_apps_INSTALL_PREFIX}lib${LIB_SUFFIX})

=== apps/mrpt-performance/CMakeLists.txt ===
INCLUDE(../../cmakemodules/AssureCMakeRootFile.cmake) # Avoid user mistake in CMake source directory

#-----------------------------------------------------------------
# CMake file for the MRPT application:  mrpt-performance
#
#  Run with "cmake ." at the root directory
#
#  October 2007, Jose Luis Blanco <jlblanco@ctima.uma.es>
#-----------------------------------------------------------------
PROJECT(mrpt_performance)


# ---------------------------------------------
# TARGET:
# ---------------------------------------------

ADD_DEFINITIONS(-DMRPT_DATASET_DIR="${MRPT_SOURCE_DIR}/share/mrpt/datasets")
ADD_DEFINITIONS(-DMRPT_DOC_PERF_DIR="${MRPT_SOURCE_DIR}/doc/perf-data")

# Define the executable target:
ADD_EXECUTABLE(mrpt-performance
	perf-main.cpp
	run_build_tables.h
	# Test files:
	perf-feature_extraction.h
	perf-feature_matching.h
	perf-graph.h
	perf-gridmaps.h
	perf-icp.h
	perf-images.h
	perf-math.h
	perf-matrix.h
	perf-pointmaps.h
	perf-poses.h
	perf-random.h
	perf-scan_matching.h
	)

SET(TMP_TARGET_NAME "mrpt-performance")

SET_TARGET_PROPERTIES(${TMP_TARGET_NAME} PROPERTIES PROJECT_LABEL "(APP) ${TMP_TARGET_NAME}")

# Add the required libraries for linking:
TARGET_LINK_LIBRARIES(${TMP_TARGET_NAME} ${MRPT_LINKER_LIBS})

# Dependencies on MRPT libraries:
#  Just mention the top-level dependency, the rest will be detected automatically,
#  and all the needed #include<> dirs added (see the script DeclareAppDependencies.cmake for further details)
DeclareAppDependencies(${TMP_TARGET_NAME} mrpt-slam mrpt-gui mrpt-scanmatching)


# ----------------------------------------------------------------------------
#   				INSTALL
# ----------------------------------------------------------------------------
INSTALL(TARGETS mrpt-performance
	RUNTIME DESTINATION ${mrpt_apps_INSTALL_PREFIX}bin
	LIBRARY DESTINATION ${mrpt_apps_INSTALL_PREFIX}lib${LIB_SUFFIX}
	ARCHIVE DESTINATION ${mrpt_apps_INSTALL_PREFIX}lib${LIB_SUFFIX})

=== apps/rawlog-tools/CMakeLists.txt ===
INCLUDE(../../cmakemodules/AssureCMakeRootFile.cmake) # Avoid user mistake in CMake source directory

#-----------------------------------------------------------------
# CMake file for rawlog conversion tools
#
#  Run with "cmake ." at the root directory
#-----------------------------------------------------------------
PROJECT(rawlog_tools)

# ================================================
# TARGET: rawlog-edit
# ================================================
# Define the executable target:
ADD_EXECUTABLE(rawlog-edit
	# Main:
	rawlog-edit_main.cpp
	# Headers
	rawlog-edit-declarations.h
	CRawlogProcessor.h
	# Ops:
	rawlog-edit_gps.cpp
	rawlog-edit_info.cpp
	rawlog-edit_externalize.cpp
	rawlog-edit_filters.cpp
	rawlog-edit_cuts.cpp
	rawlog-edit_sensor-poses.cpp
	)
SET(TMP_TARGET_NAME "rawlog-edit")
SET_TARGET_PROPERTIES(${TMP_TARGET_NAME} PROPERTIES PROJECT_LABEL "(APP) ${TMP_TARGET_NAME}")
# Add the required libraries for linking:
TARGET_LINK_LIBRARIES(${TMP_TARGET_NAME} ${MRPT_LINKER_LIBS})
INSTALL(TARGETS ${TMP_TARGET_NAME}
	RUNTIME DESTINATION ${mrpt_apps_INSTALL_PREFIX}bin
	LIBRARY DESTINATION ${mrpt_apps_INSTALL_PREFIX}lib${LIB_SUFFIX}
	ARCHIVE DESTINATION ${mrpt_apps_INSTALL_PREFIX}lib${LIB_SUFFIX})
# Dependencies on MRPT libraries: Just mention the top-level dependency, the rest will be detected automatically,
#  and all the needed #include<> dirs added (see the script DeclareAppDependencies.cmake for further details)
DeclareAppDependencies(${TMP_TARGET_NAME} mrpt-obs mrpt-topography)



# ================================================
# TARGET: carmen2rawlog
# ================================================
# Define the executable target:
ADD_EXECUTABLE(carmen2rawlog
	carmen2rawlog_main.cpp
	)
SET(TMP_TARGET_NAME "carmen2rawlog")
SET_TARGET_PROPERTIES(${TMP_TARGET_NAME} PROPERTIES PROJECT_LABEL "(APP) ${TMP_TARGET_NAME}")
# Add the required libraries for linking:
TARGET_LINK_LIBRARIES(${TMP_TARGET_NAME} ${MRPT_LINKER_LIBS})
INSTALL(TARGETS ${TMP_TARGET_NAME}
	RUNTIME DESTINATION ${mrpt_apps_INSTALL_PREFIX}bin
	LIBRARY DESTINATION ${mrpt_apps_INSTALL_PREFIX}lib${LIB_SUFFIX}
	ARCHIVE DESTINATION ${mrpt_apps_INSTALL_PREFIX}lib${LIB_SUFFIX})
# Dependencies on MRPT libraries: Just mention the top-level dependency, the rest will be detected automatically,
#  and all the needed #include<> dirs added (see the script DeclareAppDependencies.cmake for further details)
DeclareAppDependencies(${TMP_TARGET_NAME} mrpt-obs)


# ================================================
# TARGET: carmen2simplemap
# ================================================
# Define the executable target:
ADD_EXECUTABLE(carmen2simplemap
        carmen2simplemap_main.cpp
        )
SET(TMP_TARGET_NAME "carmen2simplemap")
SET_TARGET_PROPERTIES(${TMP_TARGET_NAME} PROPERTIES PROJECT_LABEL "(APP) ${TMP_TARGET_NAME}")
# Add the required libraries for linking:
TARGET_LINK_LIBRARIES(${TMP_TARGET_NAME} ${MRPT_LINKER_LIBS})
INSTALL(TARGETS ${TMP_TARGET_NAME}
        RUNTIME DESTINATION ${mrpt_apps_INSTALL_PREFIX}bin
        LIBRARY DESTINATION ${mrpt_apps_INSTALL_PREFIX}lib${LIB_SUFFIX}
        ARCHIVE DESTINATION ${mrpt_apps_INSTALL_PREFIX}lib${LIB_SUFFIX})
# Dependencies on MRPT libraries: Just mention the top-level dependency, the rest will be detected automatically,
#  and all the needed #include<> dirs added (see the script DeclareAppDependencies.cmake for further details)
DeclareAppDependencies(${TMP_TARGET_NAME} mrpt-obs)



if(0) # FUTURE WORK!!
# ================================================
# TARGET: rawlog2carmen
# ================================================
# Define the executable target:
ADD_EXECUTABLE(rawlog2carmen
	rawlog2carmen_main.cpp
	)
SET(TMP_TARGET_NAME "rawlog2carmen")
SET_TARGET_PROPERTIES(${TMP_TARGET_NAME} PROPERTIES PROJECT_LABEL "(APP) ${TMP_TARGET_NAME}")
# Add the required libraries for linking:
TARGET_LINK_LIBRARIES(${TMP_TARGET_NAME} ${MRPT_LINKER_LIBS})
INSTALL(TARGETS ${TMP_TARGET_NAME}
	RUNTIME DESTINATION ${mrpt_apps_INSTALL_PREFIX}bin
	LIBRARY DESTINATION ${mrpt_apps_INSTALL_PREFIX}lib${LIB_SUFFIX}
	ARCHIVE DESTINATION ${mrpt_apps_INSTALL_PREFIX}lib${LIB_SUFFIX})
# Dependencies on MRPT libraries: Just mention the top-level dependency, the rest will be detected automatically,
#  and all the needed #include<> dirs added (see the script DeclareAppDependencies.cmake for further details)
DeclareAppDependencies(${TMP_TARGET_NAME} mrpt-obs)

endif(0)

=== doc/man-pages/CMakeLists.txt ===
INCLUDE(../../cmakemodules/AssureCMakeRootFile.cmake) # Avoid user mistake in CMake source directory

# ----------------------------------------------------------------------------
# Targets for building man-pages of the MRPT
# ----------------------------------------------------------------------------

PROJECT(all_man_pages)

FIND_PROGRAM(PROG_POD2MAN pod2man)
FIND_PROGRAM(PROG_GZIP gzip)

IF (PROG_GZIP AND PROG_POD2MAN)
	MARK_AS_ADVANCED(PROG_POD2MAN)
	MARK_AS_ADVANCED(PROG_GZIP)
	
	# Make sure the output dir exists:
	FILE(MAKE_DIRECTORY "${MRPT_BINARY_DIR}/man-pages")

	# Macro for declaring man-pages targets:
	MACRO(CREATE_MANPAGE_PROJECT appname)
		add_custom_target(man_page_${appname}
			COMMAND 			pod2man --center="Mobile Robot Programming Toolkit - MRPT"  ${MRPT_SOURCE_DIR}/doc/man-pages/pod/${appname}.pod |gzip -c > ${MRPT_BINARY_DIR}/man-pages/${appname}.1.gz
			WORKING_DIRECTORY	${MRPT_SOURCE_DIR}/
			COMMENT 		"Generating MRPT man pages"
			)
		add_dependencies(man_pages_all man_page_${appname})
		if (UNIX AND NOT CMAKE_MRPT_USE_DEB_POSTFIXS)
			INSTALL(FILES "${MRPT_BINARY_DIR}/man-pages/${appname}.1.gz" DESTINATION share/man/man1/ )
		endif(UNIX AND NOT CMAKE_MRPT_USE_DEB_POSTFIXS)
	ENDMACRO(CREATE_MANPAGE_PROJECT)

	# The main (empty) target:
	add_custom_target(man_pages_all ALL)

	CREATE_MANPAGE_PROJECT(rawlog-grabber)
	CREATE_MANPAGE_PROJECT(RawLogViewer)
	CREATE_MANPAGE_PROJECT(ReactiveNavigationDemo)
	CREATE_MANPAGE_PROJECT(SceneViewer3D)
	CREATE_MANPAGE_PROJECT(camera-calib)
	CREATE_MANPAGE_PROJECT(icp-slam)
	CREATE_MANPAGE_PROJECT(kf-slam)
	CREATE_MANPAGE_PROJECT(2d-slam-demo)
	CREATE_MANPAGE_PROJECT(map-partition)
	CREATE_MANPAGE_PROJECT(observations2map)
	CREATE_MANPAGE_PROJECT(pf-localization)
	CREATE_MANPAGE_PROJECT(ro-localization)
	CREATE_MANPAGE_PROJECT(rbpf-slam)
	CREATE_MANPAGE_PROJECT(simul-landmarks)
	CREATE_MANPAGE_PROJECT(simul-beacons)
	CREATE_MANPAGE_PROJECT(simul-gridmap)
	CREATE_MANPAGE_PROJECT(GridmapNavSimul)
	CREATE_MANPAGE_PROJECT(grid-matching)
	CREATE_MANPAGE_PROJECT(features-matching)
	CREATE_MANPAGE_PROJECT(mrpt-performance)
	CREATE_MANPAGE_PROJECT(mono-slam)
	CREATE_MANPAGE_PROJECT(prrt-navigator-demo)
	CREATE_MANPAGE_PROJECT(navlog-viewer)
	CREATE_MANPAGE_PROJECT(hmt-slam-gui)
	CREATE_MANPAGE_PROJECT(track-video-features)
	CREATE_MANPAGE_PROJECT(graph-slam)
	CREATE_MANPAGE_PROJECT(kinect-3d-slam)

	CREATE_MANPAGE_PROJECT(rawlog-edit)
	CREATE_MANPAGE_PROJECT(carmen2rawlog)
        CREATE_MANPAGE_PROJECT(carmen2simplemap)
#	CREATE_MANPAGE_PROJECT(rawlog2carmen)

	# stereo-calib-gui: only if MRPT_OPENCV_VERSION >= 1.1.0
	IF (MRPT_OPENCV_VERSION STRGREATER "1.0.0")
		CREATE_MANPAGE_PROJECT(stereo-calib-gui)
	ENDIF (MRPT_OPENCV_VERSION STRGREATER "1.0.0")

ENDIF (PROG_GZIP AND PROG_POD2MAN)

=== libs/base/CMakeLists.txt ===

# Lists of directories with source files:
#  See "DeclareMRPTLib.cmake" for explanations
# -------------------------------------------------
macro(add_base_srcs _PATH)
	LIST(APPEND base_EXTRA_SRCS			"${MRPT_LIBS_ROOT}/base/src/${_PATH}/*.cpp" "${MRPT_LIBS_ROOT}/base/include/mrpt/${_PATH}/*.h")
	LIST(APPEND base_EXTRA_SRCS_NAME 	"${_PATH}" "${_PATH}")
endmacro(add_base_srcs)

add_base_srcs(bayes)
add_base_srcs(compress)
add_base_srcs(math)
add_base_srcs(poses)
add_base_srcs(random)
add_base_srcs(synch)
add_base_srcs(system)
add_base_srcs(utils)

LIST(APPEND base_EXTRA_SRCS			"${MRPT_LIBS_ROOT}/base/src/utils/simpleini/*.c" "${MRPT_LIBS_ROOT}/base/src/utils/simpleini/*.h")
LIST(APPEND base_EXTRA_SRCS_NAME 	"utils/simpleini" "utils/simpleini")

LIST(APPEND base_EXTRA_SRCS			"${MRPT_LIBS_ROOT}/base/src/utils/xmlparser/*.cpp" "${MRPT_LIBS_ROOT}/base/src/utils/xmlparser/*.h")
LIST(APPEND base_EXTRA_SRCS_NAME 	"utils/xmlparser" "utils/xmlparser")

# ann library:
LIST(APPEND base_EXTRA_SRCS		"${MRPT_LIBS_ROOT}/base/src/ann/*.cpp" "${MRPT_LIBS_ROOT}/base/include/mrpt/otherlibs/ann/*.h")
LIST(APPEND base_EXTRA_SRCS_NAME 	"ann" "ann")
INCLUDE_DIRECTORIES("${MRPT_LIBS_ROOT}/base/include/mrpt/otherlibs/")

# CSparse
LIST(APPEND base_EXTRA_SRCS		"${MRPT_LIBS_ROOT}/base/src/math/CSparse/*.c" "${MRPT_LIBS_ROOT}/base/include/mrpt/otherlibs/CSparse/*.h")
LIST(APPEND base_EXTRA_SRCS_NAME 	"math/CSparse" "math/CSparse")
INCLUDE_DIRECTORIES("${MRPT_LIBS_ROOT}/base/include/mrpt/otherlibs/CSparse/")

# Eigen library
LIST(APPEND base_EXTRA_SRCS		"${MRPT_LIBS_ROOT}/base/include/Eigen/*")
LIST(APPEND base_EXTRA_SRCS_NAME 	"eigen_lib")

# kmeans++
LIST(APPEND base_EXTRA_SRCS		"${MRPT_LIBS_ROOT}/base/src/math/kmeans++/*.cpp" "${MRPT_LIBS_ROOT}/base/src/math/kmeans++/*.h")
LIST(APPEND base_EXTRA_SRCS_NAME 	"math/kmeans" "math/kmeans")

# Embedded version of libjpeg for (mostly) Windows:
IF (CMAKE_MRPT_HAS_JPEG AND NOT CMAKE_MRPT_HAS_JPEG_SYSTEM)
	LIST(APPEND base_EXTRA_SRCS			"${MRPT_LIBS_ROOT}/base/src/utils/jpeglib/*.cpp" "${MRPT_LIBS_ROOT}/base/src/utils/jpeglib/*.h")
	LIST(APPEND base_EXTRA_SRCS_NAME 	"utils/jpeglib" "utils/jpeglib")
ENDIF (CMAKE_MRPT_HAS_JPEG AND NOT CMAKE_MRPT_HAS_JPEG_SYSTEM)

# Embedded version of zlib, if really needed:
# Only include zlib if not available as system library OR it's already in wxWidgets:
IF(CMAKE_MRPT_HAS_ZLIB AND NOT CMAKE_MRPT_HAS_ZLIB_SYSTEM)
	INCLUDE_DIRECTORIES("${MRPT_LIBS_ROOT}/base/src/compress/zlib/")
	IF (NOT WIN32 OR NOT CMAKE_MRPT_HAS_WXWIDGETS)
		LIST(APPEND base_EXTRA_SRCS			"${MRPT_LIBS_ROOT}/base/src/compress/zlib/*.c" "${MRPT_LIBS_ROOT}/base/src/compress/zlib/*.h")
		LIST(APPEND base_EXTRA_SRCS_NAME 	"compress/zlib" "compress/zlib")
	ENDIF (NOT WIN32 OR NOT CMAKE_MRPT_HAS_WXWIDGETS)
ENDIF(CMAKE_MRPT_HAS_ZLIB AND NOT CMAKE_MRPT_HAS_ZLIB_SYSTEM)


# Documentation files:
LIST(APPEND base_EXTRA_SRCS			"${CMAKE_SOURCE_DIR}/doc/doxygen-pages/*.h")
LIST(APPEND base_EXTRA_SRCS_NAME 	"Documentation")

#---------------------------------------------
# Macro declared in "DeclareMRPTLib.cmake":
#---------------------------------------------
define_mrpt_lib(
	base 		# Lib name
				# Dependencies: None
	)
	
# Ignore precompiled headers in some sources:
IF(MRPT_ENABLE_PRECOMPILED_HDRS)
	IF (MSVC)
		set_source_files_properties(
			${math/CSparse_FILES}
			${math/kmeans_FILES}
			${utils/xmlparser_FILES}
			${utils/simpleini_FILES}	
			${utils/jpeglib_FILES}
			${compress/zlib_FILES}
			${ann_FILES}
			PROPERTIES COMPILE_FLAGS "/Y-"
			)

	ENDIF (MSVC)
ENDIF(MRPT_ENABLE_PRECOMPILED_HDRS)

=== libs/hwdrivers/CMakeLists.txt ===
# Lists of directories with source files:
#  See "DeclareMRPTLib.cmake" for explanations
# -------------------------------------------------

# Build xSens?
IF(CMAKE_MRPT_HAS_xSENS)
	LIST(APPEND hwdrivers_EXTRA_SRCS
		"${MRPT_LIBS_ROOT}/hwdrivers/src/xSens/*.cpp"
		"${MRPT_LIBS_ROOT}/hwdrivers/src/xSens/*.h"
		)
	LIST(APPEND hwdrivers_EXTRA_SRCS_NAME 
		"xSens"
		"xSens"
		)
ENDIF(CMAKE_MRPT_HAS_xSENS)

# Build Xbox Kinect?
IF(CMAKE_MRPT_HAS_KINECT)
	# Add libfreenect, only for Kinect in Unices.
	IF (UNIX)
		LIST(APPEND hwdrivers_EXTRA_SRCS
			"${MRPT_LIBS_ROOT}/hwdrivers/src/libfreenect/*.c"
			"${MRPT_LIBS_ROOT}/hwdrivers/src/libfreenect/*.h"
			)
		LIST(APPEND hwdrivers_EXTRA_SRCS_NAME 
			"kinect"
			"kinect"
			)
	ENDIF(UNIX)
ENDIF(CMAKE_MRPT_HAS_KINECT)

# Build ARIA?
IF(CMAKE_MRPT_HAS_ARIA)
	LIST(APPEND hwdrivers_EXTRA_SRCS
		"${MRPT_LIBS_ROOT}/hwdrivers/src/aria/src/*.cpp"
		"${MRPT_LIBS_ROOT}/hwdrivers/src/aria/include/*.h"
		)
	LIST(APPEND hwdrivers_EXTRA_SRCS_NAME 
		"aria"
		"aria"
		)
ENDIF(CMAKE_MRPT_HAS_ARIA)

# Macro declared in "DeclareMRPTLib.cmake":
define_mrpt_lib(
	# Lib name
	hwdrivers 	
	# Dependencies
	mrpt-base
	mrpt-obs 
	mrpt-gui  # used to camera preview, etc.
	mrpt-opengl  # needed by mrpt-gui
	)
	
IF(CMAKE_MRPT_HAS_xSENS)
	# Ignore precompiled headers in xSens sources:
	IF(MRPT_ENABLE_PRECOMPILED_HDRS AND MSVC)
		set_source_files_properties(${xSens_FILES} PROPERTIES COMPILE_FLAGS "/Y-")
	ENDIF(MRPT_ENABLE_PRECOMPILED_HDRS AND MSVC)

	# Avoid some annoying warnings:
	IF (CMAKE_COMPILER_IS_GNUCXX)
		set_source_files_properties(${xSens_FILES} PROPERTIES COMPILE_FLAGS "-Wno-variadic-macros")
	ENDIF (CMAKE_COMPILER_IS_GNUCXX)

	ADD_DEFINITIONS(-D_LOG_TO_STDOUT)
ENDIF(CMAKE_MRPT_HAS_xSENS)

IF(CMAKE_MRPT_HAS_KINECT)
	# something special to do??...
ENDIF(CMAKE_MRPT_HAS_KINECT)

# build with link on Phidget21 lib
IF(CMAKE_MRPT_HAS_PHIDGET)
	TARGET_LINK_LIBRARIES(mrpt-hwdrivers phidget21)
ENDIF(CMAKE_MRPT_HAS_PHIDGET)

# Build with link on SVS lib
IF(CMAKE_MRPT_HAS_SVS)
	TARGET_LINK_LIBRARIES(mrpt-hwdrivers dcap)
	TARGET_LINK_LIBRARIES(mrpt-hwdrivers svs)
	TARGET_LINK_LIBRARIES(mrpt-hwdrivers svscalc)
	TARGET_LINK_LIBRARIES(mrpt-hwdrivers svscap)
ENDIF(CMAKE_MRPT_HAS_SVS)
IF(CMAKE_MRPT_HAS_ARIA)
	# Ignore precompiled headers in xSens sources:
	IF(MRPT_ENABLE_PRECOMPILED_HDRS AND MSVC)
		set_source_files_properties(${aria_FILES} PROPERTIES COMPILE_FLAGS "/Y-")
	ENDIF(MRPT_ENABLE_PRECOMPILED_HDRS AND MSVC)
	
	INCLUDE_DIRECTORIES("${MRPT_LIBS_ROOT}/hwdrivers/src/aria/include/")

	ADD_DEFINITIONS(-DARIA_STATIC)
	IF(MSVC)
		ADD_DEFINITIONS(-DWIN32)
		ADD_DEFINITIONS(-D_WINDOWS)

		IF(NOT CMAKE_BUILD_TYPE MATCHES "Debug")
			ADD_DEFINITIONS(-DNDEBUG)
		ENDIF(NOT CMAKE_BUILD_TYPE MATCHES "Debug")

		SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4267")	# Get rid of a type conversion warning in Aria lib for MSVC
	ENDIF(MSVC)

	IF(UNIX)
		TARGET_LINK_LIBRARIES(mrpt-hwdrivers dl)
	ENDIF(UNIX)
	
ENDIF(CMAKE_MRPT_HAS_ARIA)
	
# Remove the "--pedantic" flag for the file "CFFMPEG_InputStream.cpp" since headers 
#  have some errors:
IF(CMAKE_COMPILER_IS_GNUCXX AND CMAKE_MRPT_HAS_FFMPEG_SYSTEM)
	SET(EXTRA_ISYSTEMS "")
	IF(EXISTS "${LIBAVCODEC_INCLUDEDIR}")
		SET(EXTRA_ISYSTEMS "-isystem ${LIBAVCODEC_INCLUDEDIR} ")
	ENDIF(EXISTS "${LIBAVCODEC_INCLUDEDIR}")

	IF(EXISTS "${LIBAVCODEC_INCLUDEDIR}/ffmpeg")
		SET(EXTRA_ISYSTEMS "-isystem ${LIBAVCODEC_INCLUDEDIR}/ffmpeg ")
	ENDIF(EXISTS "${LIBAVCODEC_INCLUDEDIR}/ffmpeg")

	IF(EXISTS "${LIBAVCODEC_INCLUDEDIR}/libavcodec")
		SET(EXTRA_ISYSTEMS "-isystem ${LIBAVCODEC_INCLUDEDIR}/libavcodec ")
	ENDIF(EXISTS "${LIBAVCODEC_INCLUDEDIR}/libavcodec")

	IF(EXISTS "${LIBAVCODEC_INCLUDEDIR}/libavformat")
		SET(EXTRA_ISYSTEMS "-isystem ${LIBAVCODEC_INCLUDEDIR}/libavformat ")
	ENDIF(EXISTS "${LIBAVCODEC_INCLUDEDIR}/libavformat")

	set_source_files_properties(
		${MRPT_LIBS_ROOT}/hwdrivers/src/CFFMPEG_InputStream.cpp 
		PROPERTIES COMPILE_FLAGS ${EXTRA_ISYSTEMS}
		)
ENDIF(CMAKE_COMPILER_IS_GNUCXX AND CMAKE_MRPT_HAS_FFMPEG_SYSTEM)

=== libs/maps/CMakeLists.txt ===
# Lists of directories with source files:
#  See "DeclareMRPTLib.cmake" for explanations
# -------------------------------------------------
LIST(APPEND maps_EXTRA_SRCS			"${MRPT_SOURCE_DIR}/libs/maps/src/maps/*.cpp" "${MRPT_SOURCE_DIR}/libs/maps/include/mrpt/slam/*.h")
LIST(APPEND maps_EXTRA_SRCS_NAME 	"maps" "maps")

LIST(APPEND maps_EXTRA_SRCS			"${MRPT_SOURCE_DIR}/libs/maps/src/opengl/*.cpp" "${MRPT_SOURCE_DIR}/libs/maps/include/mrpt/opengl/*.h")
LIST(APPEND maps_EXTRA_SRCS_NAME 	"opengl" "opengl")

# for ann:
INCLUDE_DIRECTORIES("${MRPT_LIBS_ROOT}/base/include/mrpt/otherlibs/")
#LIST(APPEND maps_EXTRA_SRCS			"${MRPT_SOURCE_DIR}/libs/maps/src/maps/ann/*.cpp" "${MRPT_SOURCE_DIR}/libs/maps/include/mrpt/otherlibs/ann/*.h")
#LIST(APPEND maps_EXTRA_SRCS_NAME 	"ann" "ann")
#INCLUDE_DIRECTORIES("${MRPT_SOURCE_DIR}/libs/maps/include/mrpt/otherlibs/")

#---------------------------------------------
# Macro declared in "DeclareMRPTLib.cmake":
#---------------------------------------------
define_mrpt_lib(
	# Lib name
	maps
	# Dependencies:
	mrpt-obs
	# Deps of deps:
	mrpt-opengl
	mrpt-base
	)

# Ignore precompiled headers in some sources:
IF(MRPT_ENABLE_PRECOMPILED_HDRS AND MSVC)
	#...
ENDIF(MRPT_ENABLE_PRECOMPILED_HDRS AND MSVC)

=== libs/vision/CMakeLists.txt ===
# Lists of directories with source files:
#  See "DeclareMRPTLib.cmake" for explanations
# -------------------------------------------------
LIST(APPEND vision_EXTRA_SRCS		"${MRPT_SOURCE_DIR}/libs/vision/src/maps/*.cpp" "${MRPT_SOURCE_DIR}/libs/vision/include/mrpt/slam/*.h")
LIST(APPEND vision_EXTRA_SRCS_NAME 	"maps" "maps")

LIST(APPEND vision_EXTRA_SRCS		"${MRPT_SOURCE_DIR}/libs/vision/src/obs/*.cpp" "${MRPT_SOURCE_DIR}/libs/vision/include/mrpt/slam/CObservation*.h")
LIST(APPEND vision_EXTRA_SRCS_NAME 	"observations" "observations")

IF(CMAKE_MRPT_HAS_SIFT_HESS)
	LIST(APPEND vision_EXTRA_SRCS		
		"${MRPT_SOURCE_DIR}/libs/vision/src/sift-hess/imgfeatures.c" 
		"${MRPT_SOURCE_DIR}/libs/vision/src/sift-hess/sift.c" 
		"${MRPT_SOURCE_DIR}/libs/vision/src/sift-hess/utils.c" 
		"${MRPT_SOURCE_DIR}/libs/vision/include/mrpt/sift-hess/*.h")
	LIST(APPEND vision_EXTRA_SRCS_NAME 	"sift-hess" "sift-hess" "sift-hess" "sift-hess")
ENDIF(CMAKE_MRPT_HAS_SIFT_HESS)


#---------------------------------------------
# Macro declared in "DeclareMRPTLib.cmake":
#---------------------------------------------
define_mrpt_lib(
	# Lib name
	vision 		
	# Dependencies:
	mrpt-obs	
	# Deps of deps:
	mrpt-opengl  
	mrpt-base
	mrpt-gui  # used to camera preview, etc.
	mrpt-opengl  # needed by mrpt-gui
	)

	
IF(CMAKE_MRPT_HAS_SIFT_HESS)
	IF (MRPT_ENABLE_PRECOMPILED_HDRS AND MSVC)
		# Ignore precompiled headers in sift-hess sources:
		set_source_files_properties(${sift-hess_FILES} PROPERTIES COMPILE_FLAGS "/Y- /wd4244")
	ENDIF (MRPT_ENABLE_PRECOMPILED_HDRS AND MSVC)

	# Avoid some annoying warnings:
	IF (CMAKE_COMPILER_IS_GNUCXX)
		set_source_files_properties(${sift-hess_FILES} PROPERTIES COMPILE_FLAGS "-Wno-unused-function")
	ENDIF (CMAKE_COMPILER_IS_GNUCXX)
ENDIF(CMAKE_MRPT_HAS_SIFT_HESS)

=== debian/changelog ===
mrpt (1:0.9.4-1ubuntu1) natty; urgency=low

  * Merge from debian unstable (LP: #702152).  Remaining changes:
    - Add -D__STDC_CONSTANT_MACROS to CXXFLAGS to fix FTBFS due to 
      latest ffmpeg and always pass CFLAGS, CXXFLAGS, LDFLAGS during 
      build
    - Build using -0s instead of -02 on armel to work around a g++ ICE.
      LP: #635409.

 -- David Futcher <bobbo@ubuntu.com>  Tue, 25 Jan 2011 20:14:06 +0000

mrpt (1:0.9.4-1) unstable; urgency=low

  * New version of upstream sources.
  * Solved build and "make test" errors (Closes: #605996, Closes: #607990)

 -- Jose Luis Blanco (University of Malaga) <joseluisblancoc@gmail.com>  Wed, 05 Jan 2011 17:07:26 +0100

mrpt (1:0.9.3-1) unstable; urgency=low

  * New version of upstream sources.

 -- Jose Luis Blanco (University of Malaga) <joseluisblancoc@gmail.com>  Sun, 19 Dec 2010 18:03:40 +0100

mrpt (1:0.9.2-1) unstable; urgency=low

  * New version of upstream sources.
  * Solves FTBFS error (Closes: 599989)

 -- Jose Luis Blanco (University of Malaga) <joseluisblancoc@gmail.com>  Thu, 28 Oct 2010 10:47:31 +0200

=== debian/control ===
Source: mrpt
Section: science
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Jose Luis Blanco (University of Malaga) <joseluisblancoc@gmail.com>
Build-Depends: debhelper (>= 5), 
               autotools-dev,
               cmake,
               perl,
               zlib1g-dev,
               libjpeg62-dev,
               libwxgtk2.8-dev,
               wx2.8-headers,
               libftdi-dev,
               freeglut3-dev,
               libcv-dev,
               libcvaux-dev,
               libhighgui-dev,
               doxygen,
               ghostscript,
               graphviz,
               texlive | tetex,
               subversion,
               libdc1394-22-dev,
               libusb-1.0-0-dev,
               libeigen3-dev | perl
Standards-Version: 3.9.1
Homepage: http://www.mrpt.org/

Package: mrpt-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Mobile Robot Programming Toolkit - Documentation and examples
 The Mobile Robot Programming Toolkit (MRPT) is an extensive, cross-platform,
 and open source C++ library aimed to help robotics researchers to design and
 implement algorithms in the fields of Simultaneous Localization and Mapping 
 (SLAM), computer vision, and motion planning (obstacle avoidance).
 .
 The libraries include classes for easily managing 3D(6D) geometry, 
 probability density functions (pdfs) over many predefined variables (points 
 and poses, landmarks, maps), Bayesian inference (Kalman filters, particle 
 filters), image processing, path planning and obstacle avoidance, 3D 
 visualization of all kind of maps (points, occupancy grids, landmarks,...), 
 etc.
 Gathering, manipulating and inspecting very large robotic datasets (Rawlogs)
 efficiently is another goal of MRPT, supported by several classes and 
 applications.
 .
 The MRPT is free software and is released under the GPL. 
 .
 This package provides the documentation and examples of MRPT, and the book
  Writing Scientific Applications with the Mobile Robot Programming Toolkit 
  in .ps.gz format.

Package: libmrpt-base0.9
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Mobile Robot Programming Toolkit - base library
 The Mobile Robot Programming Toolkit (MRPT) is an extensive, cross-platform,
 and open source C++ library aimed to help robotics researchers to design and
 implement algorithms in the fields of Simultaneous Localization and Mapping 
 (SLAM), computer vision, and motion planning (obstacle avoidance).
 .
 This package includes the mrpt-base library. 
 . 
 More about MRPT libraries in: http://www.mrpt.org/Libraries

Package: libmrpt-opengl0.9
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
	  libmrpt-base0.9
Description: Mobile Robot Programming Toolkit - opengl library
 The Mobile Robot Programming Toolkit (MRPT) is an extensive, cross-platform,
 and open source C++ library aimed to help robotics researchers to design and
 implement algorithms in the fields of Simultaneous Localization and Mapping 
 (SLAM), computer vision, and motion planning (obstacle avoidance).
 .
 This package includes the mrpt-opengl library. 
 . 
 More about MRPT libraries in: http://www.mrpt.org/Libraries

Package: libmrpt-bayes0.9
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
          libmrpt-base0.9
Description: Mobile Robot Programming Toolkit - bayes library
 The Mobile Robot Programming Toolkit (MRPT) is an extensive, cross-platform,
 and open source C++ library aimed to help robotics researchers to design and
 implement algorithms in the fields of Simultaneous Localization and Mapping
 (SLAM), computer vision, and motion planning (obstacle avoidance).
 .
 This package includes the mrpt-bayes library (mostly, Kalman filter and 
 particle filters)
 .
 More about MRPT libraries in: http://www.mrpt.org/Libraries



Package: libmrpt-gui0.9
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
	  libmrpt-opengl0.9
Description: Mobile Robot Programming Toolkit - gui library
 The Mobile Robot Programming Toolkit (MRPT) is an extensive, cross-platform,
 and open source C++ library aimed to help robotics researchers to design and
 implement algorithms in the fields of Simultaneous Localization and Mapping 
 (SLAM), computer vision, and motion planning (obstacle avoidance).
 .
 This package includes the mrpt-gui library. 
 . 
 More about MRPT libraries in: http://www.mrpt.org/Libraries

Package: libmrpt-obs0.9
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
	  libmrpt-opengl0.9
Description: Mobile Robot Programming Toolkit - obs library
 The Mobile Robot Programming Toolkit (MRPT) is an extensive, cross-platform,
 and open source C++ library aimed to help robotics researchers to design and
 implement algorithms in the fields of Simultaneous Localization and Mapping 
 (SLAM), computer vision, and motion planning (obstacle avoidance).
 .
 This package includes the mrpt-obs library. 
 . 
 More about MRPT libraries in: http://www.mrpt.org/Libraries

Package: libmrpt-maps0.9
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
	  libmrpt-obs0.9
Description: Mobile Robot Programming Toolkit - maps library
 The Mobile Robot Programming Toolkit (MRPT) is an extensive, cross-platform,
 and open source C++ library aimed to help robotics researchers to design and
 implement algorithms in the fields of Simultaneous Localization and Mapping 
 (SLAM), computer vision, and motion planning (obstacle avoidance).
 .
 This package includes the mrpt-maps library. 
 . 
 More about MRPT libraries in: http://www.mrpt.org/Libraries


Package: libmrpt-hwdrivers0.9
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
	  libmrpt-obs0.9,
	  libmrpt-gui0.9
Description: Mobile Robot Programming Toolkit - hwdrivers library
 The Mobile Robot Programming Toolkit (MRPT) is an extensive, cross-platform,
 and open source C++ library aimed to help robotics researchers to design and
 implement algorithms in the fields of Simultaneous Localization and Mapping 
 (SLAM), computer vision, and motion planning (obstacle avoidance).
 .
 This package includes the mrpt-hwdrivers library. 
 . 
 More about MRPT libraries in: http://www.mrpt.org/Libraries


Package: libmrpt-vision0.9
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
	  libmrpt-obs0.9
Description: Mobile Robot Programming Toolkit - vision library
 The Mobile Robot Programming Toolkit (MRPT) is an extensive, cross-platform,
 and open source C++ library aimed to help robotics researchers to design and
 implement algorithms in the fields of Simultaneous Localization and Mapping 
 (SLAM), computer vision, and motion planning (obstacle avoidance).
 .
 This package includes the mrpt-vision library. 
 . 
 More about MRPT libraries in: http://www.mrpt.org/Libraries

Package: libmrpt-scanmatching0.9
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
          libmrpt-base0.9
Description: Mobile Robot Programming Toolkit - scanmatching library
 The Mobile Robot Programming Toolkit (MRPT) is an extensive, cross-platform,
 and open source C++ library aimed to help robotics researchers to design and
 implement algorithms in the fields of Simultaneous Localization and Mapping
 (SLAM), computer vision, and motion planning (obstacle avoidance).
 .
 This package includes the mrpt-scanmatching library.
 .
 More about MRPT libraries in: http://www.mrpt.org/Libraries


Package: libmrpt-topography0.9
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
	  libmrpt-scanmatching0.9,
	  libmrpt-obs0.9
Description: Mobile Robot Programming Toolkit - topography library
 The Mobile Robot Programming Toolkit (MRPT) is an extensive, cross-platform,
 and open source C++ library aimed to help robotics researchers to design and
 implement algorithms in the fields of Simultaneous Localization and Mapping 
 (SLAM), computer vision, and motion planning (obstacle avoidance).
 .
 This package includes the mrpt-topography library. 
 . 
 More about MRPT libraries in: http://www.mrpt.org/Libraries


Package: libmrpt-detectors0.9
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
	  libmrpt-maps0.9,
	  libmrpt-vision0.9,
	  libmrpt-gui0.9
Description: Mobile Robot Programming Toolkit - detectors library
 The Mobile Robot Programming Toolkit (MRPT) is an extensive, cross-platform,
 and open source C++ library aimed to help robotics researchers to design and
 implement algorithms in the fields of Simultaneous Localization and Mapping 
 (SLAM), computer vision, and motion planning (obstacle avoidance).
 .
 This package includes the mrpt-detectors library. 
 . 
 More about MRPT libraries in: http://www.mrpt.org/Libraries


Package: libmrpt-slam0.9
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
	  libmrpt-maps0.9,
	  libmrpt-vision0.9,
	  libmrpt-scanmatching0.9,
	  libmrpt-bayes0.9
Description: Mobile Robot Programming Toolkit - slam library
 The Mobile Robot Programming Toolkit (MRPT) is an extensive, cross-platform,
 and open source C++ library aimed to help robotics researchers to design and
 implement algorithms in the fields of Simultaneous Localization and Mapping 
 (SLAM), computer vision, and motion planning (obstacle avoidance).
 .
 This package includes the mrpt-slam library. 
 . 
 More about MRPT libraries in: http://www.mrpt.org/Libraries


Package: libmrpt-reactivenav0.9
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
	  libmrpt-maps0.9
Description: Mobile Robot Programming Toolkit - reactivenav library
 The Mobile Robot Programming Toolkit (MRPT) is an extensive, cross-platform,
 and open source C++ library aimed to help robotics researchers to design and
 implement algorithms in the fields of Simultaneous Localization and Mapping 
 (SLAM), computer vision, and motion planning (obstacle avoidance).
 .
 This package includes the mrpt-reactivenav library. 
 . 
 More about MRPT libraries in: http://www.mrpt.org/Libraries


Package: libmrpt-hmtslam0.9
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
	  libmrpt-slam0.9
Description: Mobile Robot Programming Toolkit - hmtslam library
 The Mobile Robot Programming Toolkit (MRPT) is an extensive, cross-platform,
 and open source C++ library aimed to help robotics researchers to design and
 implement algorithms in the fields of Simultaneous Localization and Mapping 
 (SLAM), computer vision, and motion planning (obstacle avoidance).
 .
 This package includes the mrpt-hmtslam library. 
 . 
 More about MRPT libraries in: http://www.mrpt.org/Libraries


Package: mrpt-libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, 
         libmrpt-base0.9, 
         libmrpt-opengl0.9, 
         libmrpt-scanmatching0.9,
         libmrpt-bayes0.9,
         libmrpt-gui0.9, 
         libmrpt-obs0.9, 
         libmrpt-maps0.9, 
         libmrpt-vision0.9, 
         libmrpt-slam0.9, 
         libmrpt-topography0.9, 
         libmrpt-detectors0.9, 
         libmrpt-hwdrivers0.9,
         libmrpt-reactivenav0.9,
         libmrpt-hmtslam0.9
Description: Mobile Robot Programming Toolkit - All the libraries
 The Mobile Robot Programming Toolkit (MRPT) is an extensive, cross-platform,
 and open source C++ library aimed to help robotics researchers to design and
 implement algorithms in the fields of Simultaneous Localization and Mapping 
 (SLAM), computer vision, and motion planning (obstacle avoidance).
 .
 This virtual package depends on all MRPT libraries.



Package: libmrpt-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends},
         mrpt-libs
Description: Mobile Robot Programming Toolkit - Development headers
 The Mobile Robot Programming Toolkit (MRPT) is an extensive, cross-platform,

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Makefile for MRPT Debian package.

# Uncomment this to turn on verbose mode.
export DH_DEBUG=1
export DH_VERBOSE=1


# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_ARCH  ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
CXXFLAGS += -D__STDC_CONSTANT_MACROS
ifeq ($(DEB_HOST_ARCH),armel)
  CFLAGS += -Os
  CXXFLAGS += -Os
endif

config.status: configure
	dh_testdir
	# Add here commands to configure the package.
	./configure MRPT_IS_DEB_PACKAGE=1 --host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) --prefix=/usr --mandir=\$${prefix}/share/man --infodir=\$${prefix}/share/info CFLAGS="$(CFLAGS)" CXXFLAGS="$(CXXFLAGS)" LDFLAGS="-Wl,-z,defs"

build: build-stamp

build-stamp:  config.status
	dh_testdir

	touch $@

distclean:
    # Nothing to do (do not remove this line!)

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp 

	# Add here commands to clean up after the build process.
	rm -f config.sub config.guess

	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_clean -k 
	dh_installdirs

	# Add here commands to install the package into debian/mrpt.
	./configure MRPT_IS_DEB_PACKAGE=1 --prefix=$(CURDIR)/debian/ CMAKE_MRPT_USE_DEB_POSTFIXS="1" CFLAGS="$(CFLAGS)" CXXFLAGS="$(CXXFLAGS)" LDFLAGS="-Wl,-z,defs"

	# Create mrpt documentation
	make documentation_html
	# Create man pages:
	make man_pages_all
	# Build all
	$(MAKE) VERBOSE=1
	# Run tests
	make test || echo "\n\n**************\n* WARNING: Some unit tests failed: this may be a real error or an artifact if this is building in some virtualization platform.\n*****************\n\n"

	# Install
	$(MAKE) install
	
	# Move all the ".so" files to the proper place: the -dev package:
	mkdir -p $(CURDIR)/debian/libmrpt-dev/usr/lib/
	# 1: copy (-P: don't dereference symbolic link)
	find $(CURDIR)/debian/ -name "*.so" | xargs -I FIL cp -P FIL $(CURDIR)/debian/libmrpt-dev/usr/lib/
	# 2: remove from the old location (this is to avoid "mv" to complaing if moving to the same location)
	find $(CURDIR)/debian/ -name "*.so" | grep -v 'libmrpt-dev' | xargs rm 
	
# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs 
	dh_installdocs
	dh_installmenu
	dh_installmime -p mrpt-core
	dh_installman -p mrpt-apps $(CURDIR)/man-pages/*.1*
	# Register .desktop files with a MIME type:
#	dh_desktop -p mrpt-apps
	dh_link
#	dh_strip --dbg-package=libmrpt-core-dbg
	dh_strip
	dh_compress
	dh_fixperms
	#export LD_LIBRARY_PATH=$(CURDIR)/debian/libmrpt-base0.X/usr/lib
	dh_makeshlibs -a
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install
